//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "direct.h"
#include "stdio.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------



void __fastcall TMainForm::btnDemo1Click(TObject *Sender)
{
	long id;
	long isMultiPage; 
	long xdpi, ydpi;
	long iCompression;
	char sOutTifFname[_MAX_PATH];

	if( Load() ){
		if( id = oakBegin() ){

			//=============================================================
			//set output file
			isMultiPage = FALSE;
			strcpy(sOutTifFname, "lzw.tif");
			oakSetOption(id, OAK_Set_Output, OAK_FILE_TIF, isMultiPage, sOutTifFname, NULL);
			
			//set dpi
			xdpi = 150, ydpi = 150;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);
			
			//set COMPRESSION
			iCompression = OAK_COMPRESSION_LZW;
			oakSetOption(id, OAK_Set_Compression, iCompression, 0, NULL, NULL);
			
			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test1.pcl", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test2.pcl", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test3.pcl", NULL);
			
			//strat convert
			oakExport(id);

			oakEnd(id);
		}

		if( id = oakBegin() ){

			//=============================================================
			//set output file
			isMultiPage = TRUE;
			strcpy(sOutTifFname, "MultiPage_g4.tif");
			oakSetOption(id, OAK_Set_Output, OAK_FILE_TIF, isMultiPage, sOutTifFname, NULL);
			
			//set dpi
			xdpi = 150, ydpi = 150;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);
			
			//set Color Depth
			oakSetOption(id, OAK_Set_ColorDepth, oak_color_1, 0, NULL, NULL);

			//set COMPRESSION
			iCompression = OAK_COMPRESSION_G4;
			oakSetOption(id, OAK_Set_Compression, iCompression, 0, NULL, NULL);
			
			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test1.pcl", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test2.pcl", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test3.pcl", NULL);
			
			//strat convert
			oakExport(id);

			oakEnd(id);
		}

		if( id = oakBegin() ){
			//=============================================================
			//set output file
			strcpy(sOutTifFname, "outputa.jpg");
			oakSetOption(id, OAK_Set_Output, OAK_FILE_JPG, 0, sOutTifFname, NULL);
				
			//set dpi
			xdpi = 150, ydpi = 150;
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);

			//set jpeg quality (1 - 100)
			oakSetOption(id, OAK_Set_Quality, 75, 0, NULL, NULL);
					
			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test1.pcl", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test2.pcl", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test3.pcl", NULL);
			
			//strat convert
			oakExport(id);

			oakEnd(id);
		}

		Free();                
	}else{
		MessageBox(NULL,"Loading pcltotiff.dll failure!", "demo", MB_OK);
	}
}

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------



BOOL TMainForm::Load(){
	char szDLL[] = "pcltoimage.dll";

	hmodule=LoadLibrary(szDLL);
	if(hmodule==NULL)
		goto Failer;

	oakBegin=(poakBegin)GetProcAddress(hmodule,"_oakBegin@0");
	if(oakBegin==NULL)
		goto Failer;
	oakEnd=(poakEnd)GetProcAddress(hmodule,"_oakEnd@4");
	if(oakEnd==NULL)
		goto Failer;
	oakExport=(poakExport)GetProcAddress(hmodule,"_oakExport@4");
	if(oakExport==NULL)
		goto Failer;
	oakSetOption=(poakSetOption)GetProcAddress(hmodule,"_oakSetOption@24");
	if(oakSetOption==NULL)
		goto Failer;
	oakGetOption=(poakGetOption)GetProcAddress(hmodule,"_oakGetOption@24");
	if(oakGetOption==NULL)
		goto Failer;
	return TRUE;

Failer:
	Free(); 
	return FALSE;
}


void TMainForm::Free(){
	if(hmodule==NULL)
        return;
	FreeLibrary(hmodule);
	hmodule=NULL;
}

