unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;

const
  //Definitions of oakSetOption's nIndex properties
  //==============================================================================================================
  OAK_Set_Output       =  2101;
  OAK_Set_Input        =  2102;
  OAK_Set_DPI          =  2103;
  OAK_Set_ColorDepth   =  2104;
  OAK_Set_Compression  =  2108;
  OAK_Set_Quality      =  2109;

  //file type's definitions
  //==============================================================================================================
  OAK_FILE_TIF        =  105;
  OAK_FILE_JPG        =  106;
  OAK_FILE_BMP        =  107;
  OAK_FILE_GIF        =  108;
  OAK_FILE_PCX        =  109;
  OAK_FILE_PNG        =  110;
  OAK_FILE_EMF        =  111;
  OAK_FILE_WMF        =  112;
  
  //TIFF tag's definitions.
  //==============================================================================================================
  OAK_COMPRESSION_NONE        =  1;
  OAK_COMPRESSION_RLE         =  2;
  OAK_COMPRESSION_G3          =  3;
  OAK_COMPRESSION_G4          =  4;
  OAK_COMPRESSION_LZW         =  5;
  OAK_COMPRESSION_JPEG        =  6;
  OAK_COMPRESSION_PACKBITS    =  7;

  //Color Depth
  //==============================================================================================================
  oak_color_1 = 1;    //2 colors
  oak_color_4 = 4;    //16 colors
  oak_color_8_g = 7;  //256 grayscale colors
  oak_color_8 = 8;    //256 colors
  oak_color_24 = 24;  //true colors



type

  //interface definitions.
  //==========================================================================================
    _oakBegin = function():Longint; stdcall;
    _oakEnd = function(nHandle:Longint):Longint; stdcall;
    _oakExport = function(nHandle:Longint):Longint; stdcall;
    _oakSetOption = function( nHandle:Longint; //Conversion object's handle.
                          nIndex:Longint;  //Property tag,refer to the following property definitions.
                          nValue1:Longint;
                          nValue2:Longint;
                          pValue1:PChar;
                          pValue2:PChar):Longint; stdcall;
    _oakGetOption = function( nHandle:Longint; //Conversion object's handle.
                          nIndex:Longint;  //Property tag,refer to the following property definitions.
                          nValue1:Longint;
                          nValue2:Longint;
                          pValue1:PChar;
                          pValue2:PChar):Longint; stdcall;

  //==========================================================================================




  TMainForm = class(TForm)
    btnDemo1: TButton;
    m_ProgressBar: TProgressBar;
    procedure btnDemo1Click(Sender: TObject);
  private
    { Private declarations }


    //---------------------------------------------------------------------------
    m_hDll: HMODULE;
    oakBegin: _oakBegin;
    oakEnd: _oakEnd;
    oakExport: _oakExport;
    oakSetOption: _oakSetOption;
    oakGetOption: _oakGetOption;

    function LoadDLL():BOOL;
    function FreeDLL():BOOL;  
    //----------------------------------------------------------------------------

  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

//==========================================================================================
function TMainForm.LoadDLL():BOOL;
var
   sDllFile: PAnsiChar;
   pFunc: FARPROC;
label
   ERR_FLAG;
begin
   sDllFile := 'pcltoimage.dll';
   m_hDll := LoadLibrary(sDllFile);
   if m_hDll = 0 then
   begin
      Result := FALSE;
      exit;
   end;

	 pFunc := GetProcAddress(m_hDll, '_oakBegin@0');
	 if pFunc = nil then goto ERR_FLAG;
   oakBegin := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakEnd@4');
	 if pFunc = nil then goto ERR_FLAG;
   oakEnd := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakExport@4');
	 if pFunc = nil then goto ERR_FLAG;
   oakExport := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakSetOption@24');
	 if pFunc = nil then goto ERR_FLAG;
   oakSetOption := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakGetOption@24');
	 if pFunc = nil then goto ERR_FLAG;
   oakGetOption := pFunc;

   Result := TRUE;
   exit;

ERR_FLAG:
   Result := FALSE;
end;


//==========================================================================================

function TMainForm.FreeDLL():BOOL;
begin
	if m_hDll <> 0  then
  begin
     FreeLibrary(m_hDll);
     m_hDll := 0;
  end;
	Result := TRUE;
end;


//==========================================================================================

procedure TMainForm.btnDemo1Click(Sender: TObject);
var
    sPdfFile: PAnsiChar;
    nHandle: Longint;
    isMultiPage: Longint;
    xdpi, ydpi: Longint;
    iCompression: Longint;
    sOutTifFname: PAnsiChar;        

begin

	if LoadDLL() = TRUE then
  begin

  //====================================================
    nHandle := oakBegin();
		if nHandle <> 0 then
    begin
			//set output file
			isMultiPage := 0;
			sOutTifFname := 'lzw.tif';
			oakSetOption(nHandle, OAK_Set_Output, OAK_FILE_TIF, isMultiPage, sOutTifFname, nil);

			//set  dpi
			xdpi := 150;
      ydpi := 150;
			oakSetOption(nHandle, OAK_Set_DPI, xdpi, ydpi, nil, nil);

			//set  compress
			iCompression := OAK_COMPRESSION_LZW;
			oakSetOption(nHandle, OAK_Set_Compression, iCompression, 0, nil, nil);

			//set input file
			oakSetOption(nHandle, OAK_Set_Input, 0, 0, './pcl_files/test1.pcl', nil);
			oakSetOption(nHandle, OAK_Set_Input, 0, 0, './pcl_files/test2.pcl', nil);
			oakSetOption(nHandle, OAK_Set_Input, 0, 0, './pcl_files/test3.pcl', nil);

			//strat convert
			oakExport(nHandle);

 			oakEnd(nHandle);
		end;

      //====================================================
    nHandle := oakBegin();
		if nHandle <> 0 then
    begin
			//set output file
			isMultiPage := 1;
			sOutTifFname := 'MultiPage_g4.tif';
			oakSetOption(nHandle, OAK_Set_Output, OAK_FILE_TIF, isMultiPage, sOutTifFname, nil);

			//set  dpi
			xdpi := 150;
      ydpi := 150;
			oakSetOption(nHandle, OAK_Set_DPI, xdpi, ydpi, nil, nil);

      //Color Depth
      oakSetOption(nHandle, OAK_Set_ColorDepth, oak_color_1, 0, nil, nil);
      
			//set  compress
			iCompression := OAK_COMPRESSION_G4;
			oakSetOption(nHandle, OAK_Set_Compression, iCompression, 0, nil, nil);

			//set input file
			oakSetOption(nHandle, OAK_Set_Input, 0, 0, './pcl_files/test1.pcl', nil);
			oakSetOption(nHandle, OAK_Set_Input, 0, 0, './pcl_files/test2.pcl', nil);
			oakSetOption(nHandle, OAK_Set_Input, 0, 0, './pcl_files/test3.pcl', nil);

			//strat convert
			oakExport(nHandle);

 			oakEnd(nHandle);
		end;
      //====================================================
    nHandle := oakBegin();
		if nHandle <> 0 then
    begin
			//set output file
			sOutTifFname := 'output.jpg';
			oakSetOption(nHandle, OAK_Set_Output, OAK_FILE_JPG, 0, sOutTifFname, nil);

			//set  dpi
			xdpi := 150;
      ydpi := 150;
			oakSetOption(nHandle, OAK_Set_DPI, xdpi, ydpi, nil, nil);

			//set jpeg quality (1 - 100)
			oakSetOption(nHandle, OAK_Set_Quality, 75, 0, nil, nil);      

			//set input file
			oakSetOption(nHandle, OAK_Set_Input, 0, 0, './pcl_files/test1.pcl', nil);
			oakSetOption(nHandle, OAK_Set_Input, 0, 0, './pcl_files/test2.pcl', nil);
			oakSetOption(nHandle, OAK_Set_Input, 0, 0, './pcl_files/test3.pcl', nil);

			//strat convert
			oakExport(nHandle);


			oakEnd(nHandle);
		end;
		FreeDLL();
    ShowMessage('Conversion successful!');
  end
	else
		ShowMessage('Loading dll failure!');



end;



//==========================================================================================


end.
